Austin Group Defect Tracker

Aardvark Mark IV


Viewing Issue Simple Details Jump to Notes ] Issue History ] Print ]
ID Category Severity Type Date Submitted Last Update
0000598 [1003.1(2008)/Issue 7] System Interfaces Objection Omission 2012-08-08 13:22 2020-09-03 15:25
Reporter eblake View Status public  
Assigned To ajosey
Priority normal Resolution Accepted As Marked  
Status Resolved  
Name Eric Blake
Organization Red Hat
User Reference ebb.OH
Section mkdtemp
Page Number 1292
Line Number 42417
Interp Status ---
Final Accepted Text Note: 0004968
Summary 0000598: OH shading and new interfaces
Description 0000411 proposed several new interfaces that use constants not currently provided by the header that the interface is declared in. These new interfaces either need to use OH shading (see 0000591) or the headers for these interfaces need alteration to become self-contained (see 0000593).

The desired action takes the approach of using OH shading. This was done in part to avoid conflicts with 0000593; even though the solution for that bug proposes exposing several O_* constants under XSI shading, mkostemp was proposed for CX shading and needs even more constants.

An alternative action would be to make <stdlib.h> self-contained under CX shading rather than just XSI, and to make <unistd.h> self-contained and permitted to leak symbols from <fcntl.h>. Taken to an extreme, this solution would also suggest making AT_FDCWD and friends exposed in all headers that use the *at interfaces, and getting rid of OH shading altogether in Issue 8 (basically, undoing the TC2 changes of 0000591 by instead making all headers self-contained). As this change would be more invasive, I did not attempt to enumerate the changes required, unless the group feels this is a better direction to head for Issue 8.
Desired Action Drop these changes from 0000411:

After line 24867 [XSH dup SYNOPSIS], add a line:
int dup3(int fildes, int fildes2, int flag);

After line 42416 [XSH mkdtemp SYNOPSIS], add a line:
int mkostemp (char *template, int flag);



and replace them with these changes instead:

After line 24867 [XSH dup SYNOPSIS], add two lines, shaded as follows:
<OH>#include <fcntl.h></OH>
int dup3(int fildes, int fildes2, int flag);

After line 42417 [XSH mkdtemp SYNOPSIS], add two lines, shaded as follows:
<OH>#include <fcntl.h></OH>
<CX>int mkostemp (char *template, int flag);</CX>
Tags issue8
Attached Files

- Relationships
related to 0000593Appliedajosey 1003.1(2008)/Issue 7 posix_typed_mem_open requires the use of <fcntl.h> 
related to 0001350Applied Issue 8 drafts O_* constants needed in <stdlib.h> for mkostemp() 
child of 0000411Appliedajosey 1003.1(2008)/Issue 7 adding atomic FD_CLOEXEC support 
child of 0000591Closedajosey 1003.1(2008)/Issue 7 No reason for OH margins in the synopses of open and creat 

-  Notes
(0004968)
geoffclare (manager)
2020-09-03 15:22
edited on: 2020-09-03 15:34

On 2016 edition page 441 line 15099 section <unistd.h>, add:
The <unistd.h> header shall define the symbolic constants O_CLOEXEC and O_CLOFORK as described in <fcntl.h>.

On 2016 edition page 449 line 15466 section <unistd.h>, change:
Inclusion of the <unistd.h> header may make visible all symbols from the headers <stddef.h>, ...
to:
Inclusion of the <unistd.h> header may make visible all symbols from the headers <fcntl.h>, <stddef.h>, ...


(0004969)
geoffclare (manager)
2020-09-03 15:24

The mkostemp() problem is fixed in bug 0001350

- Issue History
Date Modified Username Field Change
2012-08-08 13:22 eblake New Issue
2012-08-08 13:22 eblake Status New => Under Review
2012-08-08 13:22 eblake Assigned To => ajosey
2012-08-08 13:22 eblake Name => Eric Blake
2012-08-08 13:22 eblake Organization => Red Hat
2012-08-08 13:22 eblake User Reference => ebb.OH
2012-08-08 13:22 eblake Section => mkdtemp
2012-08-08 13:22 eblake Page Number => 1292
2012-08-08 13:22 eblake Line Number => 42417
2012-08-08 13:22 eblake Interp Status => ---
2012-08-08 13:23 eblake Relationship added child of 0000411
2012-08-08 13:23 eblake Relationship added child of 0000591
2012-08-08 13:23 eblake Relationship added related to 0000593
2012-08-08 13:23 eblake Description Updated
2012-08-08 13:24 eblake Tag Attached: issue8
2019-05-23 16:09 geoffclare Tag Detached: issue8
2020-09-03 15:22 geoffclare Note Added: 0004968
2020-09-03 15:23 geoffclare Final Accepted Text => Note: 0004968
2020-09-03 15:23 geoffclare Status Under Review => Resolved
2020-09-03 15:23 geoffclare Resolution Open => Accepted As Marked
2020-09-03 15:23 geoffclare Tag Attached: issue8
2020-09-03 15:24 geoffclare Note Added: 0004969
2020-09-03 15:25 geoffclare Relationship added related to 0001350
2020-09-03 15:34 geoffclare Note Edited: 0004968


Mantis 1.1.6[^]
Copyright © 2000 - 2008 Mantis Group
Powered by Mantis Bugtracker